/**********************************************************************/
/* 

   Program: 	DChUti_D.prg (Utility program)
   Subject:  	Simulation fr DChoice0.prg                		
   Date: 	14.9.99
   Author(s):   Michael Scheidler  
   Comments:   */ 
/**********************************************************************/

betas   = x;

/**********      Run Forecast(s)                  **********/

""; "*** Run Forecasts ...";

k=rows(dta);
nzeil=k;
marktno   = dta[.,ord1ad];
nummer    = dta[.,ord2ad];
pax    = dta[.,depad];
share  = pax2shar(marktno,pax);
attr   = dta[.,indad];
fattr  = dta[.,four1ad];
atcor1 = dta[.,corr1ad];
atcor2 = dta[.,corr2ad];
nobeta = cols(attr)+2*four_anz;
nobetsys= cols(attr);
nopara1 =rows(corr1ad)*corr1_on;
nopara2 =rows(corr2ad)*corr2_on;
param  = betas[1:nobetsys];

fampl=0;
fphas=0;
ffreq=0;
fourpart=0;
if four_anz > 0;
 fampl  =betas[nobetsys+1:nobetsys+four_anz];
 fphas  =betas[nobetsys+four_anz+1:nobetsys+2*four_anz];
 ffreq  =seqa(1,1,four_anz);
 if (fourtyp eq 1);
  fourpart = cos(fattr*(2*pi*ffreq./Four_Per)'+fphas')*abs(fampl);
 else;
  fourpart =   sin(fattr*(2*pi*ffreq./Four_Per)')*fampl  
             + cos(fattr*(2*pi*ffreq./Four_Per)')*fphas;
 endif; 
endif;

utility= mkutil(attr,param)';
utility=utility[.,1]+fourpart; 

pacorr  = 0;
if (_model ge 30); pacorr  = betas[nobeta+1:npara]; endif;

if     (_model eq 10); /* MNL */
  sharemnp  = prepcmnl(marktno,nummer,utility);
elseif (_model eq 11);

   reg_teil = attr*param+fourpart;
   unr_teil = zeros(rows(dta),1);
   sharemnp = simulat(reg_teil,unr_teil,1,Zuf_Matr);
elseif (_model eq 21 or _model eq 30 or _model eq 35); /* MNP */
   if (_model==21); mode=1; endif;
   if (_model==30 or _model==35); mode=2; endif;
   sharemnp = prepdmnp(marktno, nummer, utility,
              nobeta, atcor1, atcor2, pacorr,
              corr1_on, corr2_on, mode);
elseif (_model == 22 or _model == 27);
   reg_teil = attr*param+fourpart;
   unr_teil = eye(rows(dta));
   sharemnp = simulat(reg_teil,unr_teil,_IterKer,Zuf_Matr);
elseif (_model == 40);
   reg_teil = attr*param+fourpart;
   gewichte = w_matrix(dta,betas,angebote,atcor1,atcor2,corr1_on,corr2_on,nobeta,mnp_func);
   T  	    = betas[nobeta+2]*eye(rows(gewichte));
   Pp  	    = eye(rows(gewichte))- betas[nobeta+1]*gewichte;
   unr_teil = T*inv(Pp);
     sharemnp= simulat(reg_teil,unr_teil,_IterKer,zuf_matr);
elseif (_model == 45);
   reg_teil = attr*param+fourpart;
     gewichte = w_matrix(dta,betas,angebote,atcor1,atcor2,corr1_on,corr2_on,nobeta,mnp_func);
   T  	    = eye(rows(gewichte)); 
   Pp  	    = eye(rows(gewichte))- betas[nobeta+1]*gewichte;
   unr_teil = T*inv(Pp);
   sharemnp= simulat(reg_teil,unr_teil,_IterKer,zuf_matr);
elseif (_model == 50);
   gewichte = w_matrix(dta,betas,angebote,atcor1,atcor2,corr1_on,corr2_on,nobeta,mnp_func);
   T   	   = betas[nobeta+2]*eye(rows(gewichte));
   Pp  	   = eye(rows(gewichte)) - betas[nobeta+1]*gewichte;
   sigma    = (inv(Pp)*T)*(inv(Pp)*T)' + eye(rows(gewichte));
   sigvec   = sig2vech(marktno,sigma);
   sharemnp = simmnp(nummer,marktno,pax,attr,param,sigvec,0);
elseif (_model == 51);
   gewichte = w_matrix(dta,betas,angebote,atcor1,atcor2,corr1_on,corr2_on,nobeta,mnp_func);
   T   	    = eye(rows(gewichte));
   Pp  	    = eye(rows(gewichte)) - betas[nobeta+1]*gewichte;
   sigma    = (inv(Pp)*T)*(inv(Pp)*T)' + eye(rows(gewichte));
   sigvec   = sig2vech(marktno,sigma);
   sharemnp = simmnp(nummer,marktno,pax,attr,param,sigvec,0);
elseif (_model == 60 or _model == 61);
   sigvec = funkc_od(atcor1,atcor2,betas,nobeta,marktno,nummer);
   sharemnp = simlke(nummer,marktno,pax,attr,param,sigvec,0);
else;
  "Simulation not yet implemented";
  stop;
endif;

 outdat	= dta~sharemnp;
 paxmnp 	= shar2pax(marktno,pax,sharemnp);
 ergebnis	= marktno~nummer~share~pax~sharemnp~paxmnp;
 p_iti		= pitimnp(marktno,nummer,pax); 
 p_itimnp	= pitimnp(marktno,nummer,paxmnp); 

